diff -ruN versions/nakedmudv3.6/src/items/portal.c src/items/portal.c
--- versions/nakedmudv3.6/src/items/portal.c	2008-05-31 00:17:59.000000000 -0400
+++ src/items/portal.c	2008-12-03 04:13:49.000000000 -0500
@@ -226,37 +226,6 @@
   }
 }
 
-void portal_from_proto(PORTAL_DATA *data, BUFFER *buf) {
-  char line[MAX_BUFFER];
-  const char *code = bufferString(buf);
-  do {
-    code = strcpyto(line, code, '\n');
-    char *lptr = line;
-    if(!strncasecmp(lptr, "me.portal_dest", 14)) {
-      while(*lptr && *lptr != '\"') lptr++;
-      lptr++; // skip leading "
-      lptr[next_letter_in(lptr, '\"')] = '\0'; // kill ending "
-      if(data->dest) free(data->dest);
-      data->dest = strdupsafe(lptr);
-    }
-    else if(!strncasecmp(lptr, "me.portal_enter_mssg", 20)) {
-      while(*lptr && *lptr != '\"') lptr++;
-      lptr++; // skip leading "
-      lptr[next_letter_in(lptr, '\"')] = '\0'; // kill ending "
-      if(data->enter_mssg) free(data->enter_mssg);
-      data->enter_mssg = strdupsafe(lptr);
-    }
-    else if(!strncasecmp(lptr, "me.portal_leave_mssg", 20)) {
-      while(*lptr && *lptr != '\"') lptr++;
-      lptr++; // skip leading "
-      lptr[next_letter_in(lptr, '\"')] = '\0'; // kill ending "
-      if(data->leave_mssg) free(data->leave_mssg);
-      data->leave_mssg = strdupsafe(lptr);
-    }
-    else; // ignore line
-  } while(*code != '\0');
-}
-
 void portal_to_proto(PORTAL_DATA *data, BUFFER *buf) {
   if(*data->dest)
     bprintf(buf, "me.portal_dest = \"%s\"\n", data->dest);
@@ -416,7 +385,7 @@
 
   // set up the portal OLC too
   item_add_olc("portal", iedit_portal_menu, iedit_portal_chooser, 
-	       iedit_portal_parser, portal_from_proto, portal_to_proto);
+	       iedit_portal_parser, NULL, portal_to_proto);
 
   // make it so we can set portal destinations in scripts
   PyObj_addGetSetter("portal_dest", PyObj_getportaldest, PyObj_setportaldest,
diff -ruN versions/nakedmudv3.6/src/items/worn.c src/items/worn.c
--- versions/nakedmudv3.6/src/items/worn.c	2008-05-31 00:17:59.000000000 -0400
+++ src/items/worn.c	2008-12-03 04:15:58.000000000 -0500
@@ -222,22 +222,6 @@
   }
 }
 
-void worn_from_proto(WORN_DATA *worn, BUFFER *buf) {
-  const char *code = bufferString(buf);
-  char        line[SMALL_BUFFER];
-  char       *lptr = line;
-
-  // parse out our worn type
-  code = strcpyto(lptr, code, '\n'); 
-  while(*lptr != '\"') lptr++;
-  lptr++; // kill the leading "
-  lptr[next_letter_in(lptr, '\"')] = '\0'; // kill closing "
-  if(hashIn(worn_table, lptr)) {
-    if(worn->type) free(worn->type);
-    worn->type = strdup(lptr);
-  }
-}
-
 void worn_to_proto(WORN_DATA *worn, BUFFER *buf) {
   bprintf(buf, "me.worn_type = \"%s\"\n", worn->type);
 }
@@ -327,7 +311,7 @@
 
   // set up the worn OLC too
   item_add_olc("worn", iedit_worn_menu, iedit_worn_chooser, iedit_worn_parser,
-	       worn_from_proto, worn_to_proto);
+	       NULL, worn_to_proto);
 
   // attach our hooks to display worn info on look
   hookAdd("append_obj_desc", append_worn_hook);
diff -ruN versions/nakedmudv3.6/src/olc2/medit.c src/olc2/medit.c
--- versions/nakedmudv3.6/src/olc2/medit.c	2008-05-31 00:17:59.000000000 -0400
+++ src/olc2/medit.c	2008-12-03 15:20:04.000000000 -0500
@@ -16,8 +16,10 @@
 #include "../world.h"
 #include "../character.h"
 #include "../prototype.h"
+#include "../handler.h"
 
 #include "olc.h"
+#include "olc_extender.h"
 
 
 
@@ -106,87 +108,14 @@
   charOLCSetParents(data, protoGetParents(proto));
   charOLCSetAbstract(data, protoIsAbstract(proto));
 
-  // this is a really ugly way to do the conversion, but basically let's
-  // just look through every line in the buffer and if we recognize some
-  // token, parse out whatever is assigned to it
-  char line[MAX_BUFFER];
-  const char *code = protoGetScript(proto);
-  do {
-    code = strcpyto(line, code, '\n');
-    char *lptr = line;
-    if(!strncmp(lptr, "me.name", 7)) {
-      while(*lptr != '\"') lptr++;
-      lptr++;                      // kill the leading "
-      lptr[strlen(lptr)-1] = '\0'; // kill the ending "
-      charSetName(ch, lptr);
-    }
-    else if(!strncmp(lptr, "me.mname", 8)) {
-      while(*lptr != '\"') lptr++;
-      lptr++;                      // kill the leading "
-      lptr[strlen(lptr)-1] = '\0'; // kill the ending "
-      charSetMultiName(ch, lptr);
-    }
-    else if(!strncmp(lptr, "me.rdesc", 8)) {
-      while(*lptr != '\"') lptr++;
-      lptr++;                      // kill the leading "
-      lptr[strlen(lptr)-1] = '\0'; // kill the ending "
-      charSetRdesc(ch, lptr);
-    }
-    else if(!strncmp(lptr, "me.mdesc", 8)) {
-      while(*lptr != '\"') lptr++;
-      lptr++;                      // kill the leading "
-      lptr[strlen(lptr)-1] = '\0'; // kill the ending "
-      charSetMultiRdesc(ch, lptr);
-    }
-    else if(!strncmp(lptr, "me.desc",  7)) {
-      // we have three "'s to skip by, because this lptr will take the form:
-      // me.desc = me.desc + " " + "..."
-      while(*lptr != '\"') lptr++; lptr++;
-      while(*lptr != '\"') lptr++; lptr++;
-      while(*lptr != '\"') lptr++; lptr++;
-      lptr[strlen(lptr)-1] = '\0'; // kill the ending "
-      charSetDesc(ch, lptr);
-      // replace our \"s with "
-      bufferReplace(charGetDescBuffer(ch), "\\\"", "\"", TRUE);
-      bufferFormat(charGetDescBuffer(ch), SCREEN_WIDTH, PARA_INDENT);
-    }
-    else if(!strncmp(lptr, "me.keywords", 11)) {
-      while(*lptr != '\"') lptr++;
-      lptr++;                                  // kill the leading "
-      lptr[next_letter_in(lptr, '\"')] = '\0'; // kill the ending "
-      charSetKeywords(ch, lptr);
-    }
-    else if(!strncmp(lptr, "me.gender", 9)) {
-      while(*lptr != '\"') lptr++;
-      lptr++;                      // kill the leading "
-      lptr[strlen(lptr)-1] = '\0'; // kill the ending "
-      charSetSex(ch, sexGetNum(lptr));
-    }
-    else if(!strncmp(lptr, "me.race", 7)) {
-      while(*lptr != '\"') lptr++;
-      lptr++;                      // kill the leading "
-      lptr[strlen(lptr)-1] = '\0'; // kill the ending "
-      charSetRace(ch, lptr);
-    }
-    else if(!strncmp(lptr, "me.attach(\"", 11)) {
-      char trigname[SMALL_BUFFER];
-      sscanf(lptr, "me.attach(\"%s", trigname);
-      // kill our ending ")
-      trigname[strlen(trigname)-2] = '\0';
-      triggerListAdd(charGetTriggers(ch), trigname);
-    }
-    else if(!strcmp(lptr, "### begin extra code")) {
-      code = strcpyto(line, code, '\n');
-      while(strcmp(line, "### end extra code") != 0) {
-	bprintf(charOLCGetExtraCode(data), "%s\n", line);
-	if(!*code) break;
-	code = strcpyto(line, code, '\n');
-      }
-    }
-    // we didn't recognize the line... just ignore it
-    else
-      continue;
-  } while(*code != '\0');
+  // build it from the prototype
+  olc_from_proto(proto, charOLCGetExtraCode(data), ch, charGetPyFormBorrowed,
+		 char_exist, char_unexist);
+  bufferFormatFromPy(charGetDescBuffer(ch));
+  bufferFormat(charGetDescBuffer(ch), SCREEN_WIDTH, PARA_INDENT);
+
+  // do all of our extender data as well
+  extenderFromProto(medit_extend, ch);
 
   return data;
 }
@@ -207,7 +136,7 @@
 
   bprintf(buf, "\n### keywords, short descs, room descs, and look descs\n");
   if(*charGetKeywords(ch))
-    bprintf(buf, "me.keywords = \"%s\"  + \", \" + me.keywords\n", 
+    bprintf(buf, "me.keywords = ', '.join([me.keywords, \"%s\"])\n",
 	    charGetKeywords(ch));
   if(*charGetName(ch))
     bprintf(buf, "me.name     = \"%s\"\n", charGetName(ch));
@@ -219,10 +148,8 @@
     bprintf(buf, "me.mdesc    = \"%s\"\n", charGetMultiRdesc(ch));
   if(*charGetDesc(ch)) {
     BUFFER *desc_copy = bufferCopy(charGetDescBuffer(ch));
-    bufferReplace(desc_copy, "\n", " ", TRUE);
-    bufferReplace(desc_copy, "\r", "",  TRUE);
-    bufferReplace(desc_copy, "\"", "\\\"", TRUE);
-    bprintf(buf, "me.desc     = me.desc + \" \" + \"%s\"\n", 
+    bufferFormatPy(desc_copy);
+    bprintf(buf, "me.desc     = me.desc + ' ' + \"%s\"\n", 
 	    bufferString(desc_copy));
     deleteBuffer(desc_copy);
   }
@@ -240,10 +167,13 @@
     LIST_ITERATOR *trig_i = newListIterator(charGetTriggers(ch));
     char            *trig = NULL;
     ITERATE_LIST(trig, trig_i) {
-      bprintf(buf, "me.attach(\"%s\")\n", trig);
+      bprintf(buf, "me.attach(\"%s\")\n",get_shortkey(trig,protoGetKey(proto)));
     } deleteListIterator(trig_i);
   }
 
+  // print all of our extender data as well
+  extenderToProto(medit_extend, ch, buf);
+
   if(bufferLength(charOLCGetExtraCode(data)) > 0) {
     bprintf(buf, "\n### begin extra code\n");
     bprintf(buf, "%s", bufferString(charOLCGetExtraCode(data)));
@@ -305,6 +235,9 @@
 		  sexGetName(charGetSex(charOLCGetChar(data))))
 		 );
 
+  // display our extender menu options
+  extenderDoMenu(sock, medit_extend, charOLCGetChar(data));
+
   // only allow code editing for people with scripting priviledges
   send_to_socket(sock, "{gC) Extra code%s\r\n", 
 		 ((!socketGetChar(sock) ||  
@@ -360,7 +293,8 @@
     text_to_buffer(sock, "Edit extra code\r\n");
     socketStartEditor(sock,script_editor,charOLCGetExtraCode(data));
     return MENU_NOCHOICE;
-  default: return MENU_CHOICE_INVALID;
+  default: 
+    return extenderDoOptChoice(sock,medit_extend,charOLCGetChar(data),*option);
   }
 }
 
@@ -397,7 +331,8 @@
     charSetSex(charOLCGetChar(data), val);
     return TRUE;
   }
-  default: return FALSE;
+  default: 
+    return extenderDoParse(sock,medit_extend,charOLCGetChar(data),choice,arg);
   }
 }
 
diff -ruN versions/nakedmudv3.6/src/olc2/module.mk src/olc2/module.mk
--- versions/nakedmudv3.6/src/olc2/module.mk	2008-05-31 00:17:59.000000000 -0400
+++ src/olc2/module.mk	2008-12-02 01:00:19.000000000 -0500
@@ -7,5 +7,6 @@
 	olc2/bedit.c      \
 	olc2/accedit.c    \
 	olc2/pcedit.c     \
-	olc2/protedit.c
+	olc2/protedit.c   \
+	olc2/olc_extender.c \
 
diff -ruN versions/nakedmudv3.6/src/olc2/oedit.c src/olc2/oedit.c
--- versions/nakedmudv3.6/src/olc2/oedit.c	2008-05-31 00:17:59.000000000 -0400
+++ src/olc2/oedit.c	2008-12-03 15:20:09.000000000 -0500
@@ -18,9 +18,11 @@
 #include "../character.h"
 #include "../extra_descs.h"
 #include "../prototype.h"
+#include "../handler.h"
 
 #include "olc.h"
 #include "olc_submenus.h"
+#include "olc_extender.h"
 
 
 
@@ -30,8 +32,6 @@
 #include "../editor/editor.h"
 #include "../scripts/scripts.h"
 #include "../scripts/script_editor.h"
-#include "../items/items.h"
-#include "../items/iedit.h"
 
 
 
@@ -99,7 +99,6 @@
   data->abstract = abstract;
 }
 
-
 //
 // takes in an obj prototype, and tries to generate an obj olc out of it. This
 // function is messy and ugly and icky and yuck. But, alas, I cannot think of
@@ -111,115 +110,23 @@
   objOLCSetParents(data, protoGetParents(proto));
   objOLCSetAbstract(data, protoIsAbstract(proto));
 
-  // this is a really ugly way to do the conversion, but basically let's
-  // just look through every line in the buffer and if we recognize some
-  // token, parse out whatever is assigned to it
-  char line[MAX_BUFFER];
-  const char *code = protoGetScript(proto);
-  do {
-    code = strcpyto(line, code, '\n');
-    char *lptr = line;
-    if(!strncmp(lptr, "me.name", 7)) {
-      while(*lptr != '\"') lptr++;
-      lptr++;                      // kill the leading "
-      lptr[strlen(lptr)-1] = '\0'; // kill the ending "
-      objSetName(obj, lptr);
-    }
-    else if(!strncmp(lptr, "me.mname", 8)) {
-      while(*lptr != '\"') lptr++;
-      lptr++;                      // kill the leading "
-      lptr[strlen(lptr)-1] = '\0'; // kill the ending "
-      objSetMultiName(obj, lptr);
-    }
-    else if(!strncmp(lptr, "me.rdesc", 8)) {
-      while(*lptr != '\"') lptr++;
-      lptr++;                      // kill the leading "
-      lptr[strlen(lptr)-1] = '\0'; // kill the ending "
-      objSetRdesc(obj, lptr);
-    }
-    else if(!strncmp(lptr, "me.mdesc", 8)) {
-      while(*lptr != '\"') lptr++;
-      lptr++;                      // kill the leading "
-      lptr[strlen(lptr)-1] = '\0'; // kill the ending "
-      objSetMultiRdesc(obj, lptr);
-    }
-    else if(!strncmp(lptr, "me.desc",  7)) {
-      // we have three "'s to skip by, because this lptr will take the form:
-      // me.desc = me.desc + " " + "..."
-      while(*lptr != '\"') lptr++; lptr++;
-      while(*lptr != '\"') lptr++; lptr++;
-      while(*lptr != '\"') lptr++; lptr++;
-      lptr[strlen(lptr)-1] = '\0'; // kill the ending "
-      objSetDesc(obj, lptr);
-      // replace our \"s with "
-      bufferReplace(objGetDescBuffer(obj), "\\\"", "\"", TRUE);
-      bufferFormat(objGetDescBuffer(obj), SCREEN_WIDTH, PARA_INDENT);
-    }
-    else if(!strncmp(lptr, "me.keywords", 11)) {
-      while(*lptr != '\"') lptr++;
-      lptr++;                                  // kill the leading "
-      lptr[next_letter_in(lptr, '\"')] = '\0'; // kill the ending "
-      objSetKeywords(obj, lptr);
-    }
-    else if(!strncmp(lptr, "me.bits", 7)) {
-      while(*lptr != '\"') lptr++;
-      lptr++;                                  // kill the leading "
-      lptr[next_letter_in(lptr, '\"')] = '\0'; // kill the ending "
-      bitSet(objGetBits(obj), lptr);
-    }
-    else if(!strncmp(lptr, "me.weight", 9)) {
-      while(*lptr != '\0' && !isdigit(*lptr)) lptr++;
-      objSetWeightRaw(obj, atof(lptr));
-    }
-    else if(!strncmp(lptr, "me.edesc(", 9)) {
-      while(*lptr != '\"') lptr++;
-      lptr++;                                              // kill the leading "
-      char *desc_start = lptr + next_letter_in(lptr, '\"') + 1;
-      lptr[next_letter_in(lptr, '\"')] = '\0';             // kill the ending "
-      while(*desc_start != '\"') desc_start++;
-      desc_start++;                                        // kill start and end
-      desc_start[next_letter_in(desc_start, '\"')] = '\0'; // "s for desc too
-      edescSetPut(objGetEdescs(obj), newEdesc(lptr, desc_start));
-    }
-    // setting an item type
-    else if(!strncmp(lptr, "me.settype(", 11)) {
-      char type[SMALL_BUFFER];
-      sscanf(lptr, "me.settype(\"%s", type);
-      // kill our ending ")
-      type[strlen(type)-2] = '\0';
-      objSetType(obj, type);
-
-      // parse out all of our type info
-      void       *data = objGetTypeData(obj, type);
-      BUFFER *type_buf = newBuffer(1);
-      code = strcpyto(line, code, '\n');
-      while(*line && strcmp(line, "### end type") != 0) {
-	bprintf(type_buf, "%s\n", line);
-	code = strcpyto(line, code, '\n');
-      }
+  // build it from the prototype
+  olc_from_proto(proto, objOLCGetExtraCode(data), obj, objGetPyFormBorrowed,
+		 obj_exist, obj_unexist);
+  bufferFormatFromPy(objGetDescBuffer(obj));
+  bufferFormat(objGetDescBuffer(obj), SCREEN_WIDTH, PARA_INDENT);
 
-      // parse out our type info
-      item_from_proto_func(type)(data, type_buf);
+  // format our extra descriptions
+  if(listSize(edescSetGetList(objGetEdescs(obj))) > 0) {
+    LIST_ITERATOR *edesc_i= newListIterator(edescSetGetList(objGetEdescs(obj)));
+    EDESC_DATA      *edesc= NULL;
+    ITERATE_LIST(edesc, edesc_i) {
+      bufferFormatFromPy(edescGetDescBuffer(edesc));
+    } deleteListIterator(edesc_i);
+  }
 
-      // garbage collection
-      deleteBuffer(type_buf);
-    }
-    else if(!strncmp(lptr, "me.attach(\"", 11)) {
-      char trigname[SMALL_BUFFER];
-      sscanf(lptr, "me.attach(\"%s", trigname);
-      // kill our ending ")
-      trigname[strlen(trigname)-2] = '\0';
-      triggerListAdd(objGetTriggers(obj), trigname);
-    }
-    else if(!strcmp(lptr, "### begin extra code")) {
-      code = strcpyto(line, code, '\n');
-      while(strcmp(line, "### end extra code") != 0) {
-	bprintf(objOLCGetExtraCode(data), "%s\n", line);
-	if(!*code) break;
-	code = strcpyto(line, code, '\n');
-      }
-    }
-  } while(*code != '\0');
+  // all of our OLC extensions
+  extenderFromProto(oedit_extend, obj);
 
   return data;
 }
@@ -234,14 +141,14 @@
   protoSetKey(proto, objOLCGetKey(data));
   protoSetParents(proto, objOLCGetParents(data));
   protoSetAbstract(proto, objOLCGetAbstract(data));
-
+  
   bprintf(buf, "### The following oproto was generated by oedit\n");
   bprintf(buf, "### If you edit this script, adhere to the stylistic\n"
 	       "### conventions laid out by oedit, or delete the top line\n");
 
   bprintf(buf, "\n### keywords, short descs, room descs, and look descs\n");
   if(*objGetKeywords(obj))
-    bprintf(buf, "me.keywords = \"%s\"  + \", \" + me.keywords\n", 
+    bprintf(buf, "me.keywords = ', '.join([me.keywords, \"%s\"])\n",
 	    objGetKeywords(obj));
   if(*objGetName(obj))
     bprintf(buf, "me.name     = \"%s\"\n", objGetName(obj));
@@ -253,10 +160,8 @@
     bprintf(buf, "me.mdesc    = \"%s\"\n", objGetMultiRdesc(obj));
   if(*objGetDesc(obj)) {
     BUFFER *desc_copy = bufferCopy(objGetDescBuffer(obj));
-    bufferReplace(desc_copy, "\n", " ", TRUE);
-    bufferReplace(desc_copy, "\r", "",  TRUE);
-    bufferReplace(desc_copy, "\"", "\\\"", TRUE);
-    bprintf(buf, "me.desc     = me.desc + \" \" + \"%s\"\n", 
+    bufferFormatPy(desc_copy);
+    bprintf(buf, "me.desc     = me.desc + ' ' + \"%s\"\n", 
 	    bufferString(desc_copy));
     deleteBuffer(desc_copy);
   }
@@ -268,8 +173,7 @@
     EDESC_DATA      *edesc= NULL;
     ITERATE_LIST(edesc, edesc_i) {
       BUFFER *desc_copy = bufferCopy(edescGetDescBuffer(edesc));
-      bufferReplace(desc_copy, "\n", " ", TRUE);
-      bufferReplace(desc_copy, "\r", "",  TRUE);
+      bufferFormatPy(desc_copy);
       bprintf(buf, "me.edesc(\"%s\", \"%s\")\n", 
 	      edescGetKeywords(edesc), bufferString(desc_copy));
       deleteBuffer(desc_copy);
@@ -278,7 +182,7 @@
 
   if(*bitvectorGetBits(objGetBits(obj))) {
     bprintf(buf, "\n### object bits\n");
-    bprintf(buf, "me.bits     = \"%s\" + \", \" + me.bits\n", 
+    bprintf(buf, "me.bits     = ', '.join([me.bits, \"%s\"])\n",
 	    bitvectorGetBits(objGetBits(obj)));
   }
 
@@ -287,30 +191,18 @@
     bprintf(buf, "me.weight   = %1.3lf\n", objGetWeightRaw(obj));
   }
 
-  // item types
-  LIST      *item_types = itemTypeList();
-  LIST_ITERATOR *type_i = newListIterator(item_types);
-  char            *type = NULL;
-  ITERATE_LIST(type, type_i) {
-    if(objIsType(obj, type)) {
-      void *data = objGetTypeData(obj, type);
-      bprintf(buf, "\n### set type: %s\n", type);
-      bprintf(buf, "me.settype(\"%s\")\n", type);
-      item_to_proto_func(type)(data, buf);      
-      bprintf(buf, "### end type\n");
-    }
-  } deleteListIterator(type_i);
-  deleteListWith(item_types, free);
-
   if(listSize(objGetTriggers(obj)) > 0) {
     bprintf(buf, "\n### object triggers\n");
     LIST_ITERATOR *trig_i = newListIterator(objGetTriggers(obj));
     char            *trig = NULL;
     ITERATE_LIST(trig, trig_i) {
-      bprintf(buf, "me.attach(\"%s\")\n", trig);
+      bprintf(buf, "me.attach(\"%s\")\n",get_shortkey(trig,protoGetKey(proto)));
     } deleteListIterator(trig_i);
   }
 
+  // all of our extender info
+  extenderToProto(oedit_extend, obj, buf);
+
   if(bufferLength(objOLCGetExtraCode(data)) > 0) {
     bprintf(buf, "\n### begin extra code\n");
     bprintf(buf, "%s", bufferString(objOLCGetExtraCode(data)));
@@ -357,7 +249,6 @@
 		 "{g8) Description:\r\n"
 		 "{c%s"
 		 "{gW) Weight         : {c%s\r\n"
-		 "{gI) Edit item types: {c%s\r\n"
 		 "{gB) Edit bitvector : {c%s\r\n"
 		 "{gT) Trigger menu\r\n"
 		 "{gX) Extra Descriptions menu\r\n",
@@ -371,10 +262,12 @@
 		 objGetMultiRdesc(objOLCGetObj(data)),
 		 objGetDesc(objOLCGetObj(data)),
 		 weight_buf,
-		 objGetTypes(objOLCGetObj(data)),
 		 bitvectorGetBits(objGetBits(objOLCGetObj(data)))
 		 );
 
+  // all of our extender menu options
+  extenderDoMenu(sock, oedit_extend, objOLCGetObj(data));
+
   // only allow code editing for people with scripting priviledges
   send_to_socket(sock, "{gC) Extra code%s\r\n", 
 		 ((!socketGetChar(sock) ||  
@@ -417,10 +310,6 @@
     do_olc(sock, edesc_set_menu, edesc_set_chooser, edesc_set_parser, NULL,NULL,
 	   NULL, NULL, objGetEdescs(objOLCGetObj(data)));
     return MENU_NOCHOICE;
-  case 'I':
-    do_olc(sock, iedit_menu, iedit_chooser, iedit_parser, NULL, NULL, NULL,
-	   NULL, objOLCGetObj(data));
-    return MENU_NOCHOICE;
   case 'B':
     do_olc(sock, bedit_menu, bedit_chooser, bedit_parser, NULL, NULL, NULL,
 	   NULL, objGetBits(objOLCGetObj(data)));
@@ -437,7 +326,8 @@
     text_to_buffer(sock, "Edit extra code\r\n");
     socketStartEditor(sock, script_editor, objOLCGetExtraCode(data));
     return MENU_NOCHOICE;
-  default: return MENU_CHOICE_INVALID;
+  default:
+    return extenderDoOptChoice(sock,oedit_extend,objOLCGetObj(data),*option);
   }
 }
 
@@ -468,7 +358,8 @@
     objSetWeightRaw(objOLCGetObj(data), val);
     return TRUE;
   }
-  default: return FALSE;
+  default:
+    return extenderDoParse(sock,oedit_extend,objOLCGetObj(data),choice,arg);
   }
 }
 
diff -ruN versions/nakedmudv3.6/src/olc2/olc.c src/olc2/olc.c
--- versions/nakedmudv3.6/src/olc2/olc.c	2008-05-31 00:17:59.000000000 -0400
+++ src/olc2/olc.c	2008-12-03 22:24:13.000000000 -0500
@@ -25,6 +25,17 @@
 #include "../object.h"
 #include "../inform.h"
 #include "olc.h"
+#include "olc_extender.h"
+
+
+
+//*****************************************************************************
+// mandatory modules
+//*****************************************************************************
+#include "../scripts/scripts.h"
+#include "../scripts/pymudsys.h"
+#include "../scripts/pysocket.h"
+#include "../scripts/pyplugs.h"
 
 
 
@@ -38,10 +49,14 @@
 
 
 //*****************************************************************************
-//
 // local data structures, defines, and functions
-//
 //*****************************************************************************
+
+// extender data for our various OLCs
+OLC_EXTENDER *medit_extend = NULL;
+OLC_EXTENDER *oedit_extend = NULL;
+OLC_EXTENDER *redit_extend = NULL;
+
 typedef struct olc_data {
   void    (* menu)(SOCKET_DATA *, void *);
   int  (* chooser)(SOCKET_DATA *, void *, const char *);
@@ -50,9 +65,11 @@
   void  (* copyto)(void *, void *);
   void (* deleter)(void *);
   void   (* saver)(void *); 
-  void *data;
-  void *working_copy;
-  int  cmd;
+
+  // the data we're working with
+  void          *data;
+  void  *working_copy;
+  int             cmd;
 } OLC_DATA;
 
 OLC_DATA *newOLC(void    (* menu)(SOCKET_DATA *, void *),
@@ -63,7 +80,7 @@
 		 void (* deleter)(void *),
 		 void   (* saver)(void *),
 		 void *data) {
-  OLC_DATA *olc     = malloc(sizeof(OLC_DATA));
+  OLC_DATA *olc     = calloc(1, sizeof(OLC_DATA));
   olc->menu         = menu;
   olc->chooser      = chooser;
   olc->parser       = parser;
@@ -72,22 +89,22 @@
   olc->deleter      = deleter;
   olc->saver        = saver;
   olc->data         = data;
-  olc->working_copy = (copier ? copier(data) : data);
   olc->cmd          = MENU_NOCHOICE;
+  olc->working_copy = (copier ? copier(data) : data);
   return olc;
 }
 
 void deleteOLC(OLC_DATA *olc) {
-  if(olc->deleter) olc->deleter(olc->working_copy);
+  // are we working with C functions or Python functions?
+  if(olc->deleter)
+    olc->deleter(olc->working_copy);
   free(olc);
 }
 
 
 
 //*****************************************************************************
-//
 // auxiliary data we put on the socket
-//
 //*****************************************************************************
 typedef struct olc_aux_data {
   LIST *olc_stack; // the list of OLCs we have opened
@@ -95,7 +112,7 @@
 
 OLC_AUX_DATA *
 newOLCAuxData() {
-  OLC_AUX_DATA *data = malloc(sizeof(OLC_AUX_DATA));
+  OLC_AUX_DATA *data = calloc(1, sizeof(OLC_AUX_DATA));
   data->olc_stack = newList();
   return data;
 }
@@ -109,9 +126,7 @@
 
 
 //*****************************************************************************
-//
 // Implementation of the OLC framework
-//
 //*****************************************************************************
 
 //
@@ -182,10 +197,8 @@
   // we're giving an argument for a menu choice we've already selected
   if(olc->cmd > MENU_NOCHOICE) {
     // the change went alright. Re-display the menu
-    if(olc->parser(sock, olc->working_copy, olc->cmd, arg)) {
+    if(olc->parser(sock, olc->working_copy, olc->cmd, arg))
       olc->cmd = MENU_NOCHOICE;
-      //olc_menu(sock);
-    }
     else
       text_to_buffer(sock, "Invalid choice!\r\nTry again: ");
   }
@@ -211,7 +224,7 @@
     case 'Q':
       // if our working copy is different from our actual data, prompt to
       // see if we want to save our changes or not
-      if(olc->saver) {
+      if(olc->saver || olc->data != olc->working_copy) {
 	text_to_buffer(sock, "Save changes (Y/N): ");
 	olc->cmd = MENU_CHOICE_CONFIRM_SAVE;
       }
@@ -617,6 +630,14 @@
   add_cmd("rrename", NULL, cmd_rrename, "builder", FALSE);
   add_cmd("zlist",   NULL, cmd_zlist,   "builder", TRUE);
   add_cmd("zreset",  NULL, cmd_zreset,  "builder", FALSE);
+
+  // build our basic OLC extenders
+  medit_extend = newExtender();
+  extenderSetPyFunc(medit_extend, charGetPyFormBorrowed);
+  oedit_extend = newExtender();
+  extenderSetPyFunc(oedit_extend, objGetPyFormBorrowed);
+  redit_extend = newExtender();
+  extenderSetPyFunc(redit_extend, roomGetPyFormBorrowed);
 }
 
 void do_olc(SOCKET_DATA *sock,
@@ -628,9 +649,9 @@
 	    void *deleter,
 	    void *saver,
 	    void *data) {
-  // first, we create a new OLC data structure, and then push it onto the stack
   OLC_DATA *olc = newOLC(menu, chooser, parser, copier, copyto, deleter,
 			 saver, data);
+
   OLC_AUX_DATA *aux_olc = socketGetAuxiliaryData(sock, "olc_aux_data");
   listPush(aux_olc->olc_stack, olc);
 
@@ -639,6 +660,61 @@
     socketPushInputHandler(sock, olc_handler, olc_menu);
 }
 
+void olc_from_proto(PROTO_DATA *proto, BUFFER *extra, void *me, void *aspy,
+		    void *togame, void *fromgame) {
+  BUFFER *to_run = newBuffer(1);
+  char line[MAX_BUFFER];
+  const char *code = protoGetScript(proto);
+  bool  extra_code = FALSE;
+
+  // go line by line and parse everything that's relevant 
+  // in 'to_run', and append everything that's not into 'extra'
+  do {
+    code = strcpyto(line, code, '\n');
+
+    // is this a begin/end marker?
+    if(!strcmp(ECODE_BEGIN, line))
+      extra_code = TRUE;
+    else if(!strcmp(ECODE_END, line))
+      extra_code = FALSE;
+    // is this relevant code, or "extra" code
+    else if(extra_code == TRUE)
+      bprintf(extra, "%s\n", line);
+    else
+      bprintf(to_run, "%s\n", line);
+  } while(*code != '\0');
+
+  // make all our arguments like functions
+  void    *(* aspy_func)(void *) = aspy;
+  void   (* togame_func)(void *) = togame;
+  void (* fromgame_func)(void *) = fromgame;
+
+  // add us to the game so we can run scripts over us
+  togame_func(me);
+
+  // make our Python stuff
+  PyObject *dict = restricted_script_dict();
+  PyObject *pyme = aspy_func(me);
+  PyDict_SetItemString(dict, "me", pyme);  
+
+  // run the script
+  run_script(dict, bufferString(to_run), get_key_locale(protoGetKey(proto)));
+
+  // make sure it ran ok
+  if(!last_script_ok())
+    log_pyerr("Error converting prototype to OLC editable structure: %s",
+	      protoGetKey(proto));
+
+
+  // remove us from the game
+  fromgame_func(me);
+
+  // clean up our garbage
+  deleteBuffer(to_run);
+  Py_DECREF(dict);
+}
+
+
 void olc_display_table(SOCKET_DATA *sock, const char *getName(int val),
 		       int num_vals, int num_cols) {
   int i, print_room;
@@ -668,8 +744,7 @@
     send_to_socket(sock, fmt, i, str, (i % num_cols == (num_cols - 1) ? 
 				       "\r\n" : "   "));
     i++;
-  }
-  deleteListIterator(list_i);
+  } deleteListIterator(list_i);
 
   if(i % num_cols != 0)
     send_to_socket(sock, "\r\n");
diff -ruN versions/nakedmudv3.6/src/olc2/olc.h src/olc2/olc.h
--- versions/nakedmudv3.6/src/olc2/olc.h	2008-05-31 00:17:59.000000000 -0400
+++ src/olc2/olc.h	2008-12-03 22:18:30.000000000 -0500
@@ -70,9 +70,12 @@
 //
 // deleter: this is a function that will delete the working copy of our data.
 //       This parameter can be NULL if the data is to be worked on directly.
-//       This function takes the form:
+//       If it is not NULL, it will be called at the completion of OLC, even if
+//       the data is being worked on directly. This is simply to allow for
+//       wrapper structures (e.g., for Python). This function takes the form:
 //       void delete(datatype *working_copy)
-#define MENU_CHOICE_CONFIRM_SAVE   (-2) // this define for internal use only!
+#define MENU_CHOICE_CONFIRM_SAVE   (-3) // this define for internal use only!
+#define MENU_CHOICE_OK             (-2) // used for olc extenders
 #define MENU_CHOICE_INVALID        (-1)
 #define MENU_NOCHOICE               (0)
 
@@ -88,6 +91,19 @@
 
 
 
+#define ECODE_BEGIN "### begin extra code"
+#define ECODE_END   "### end extra code"
+
+//
+// Pre v3.6, we'd manually parse out OLC-editable structures from Python code.
+// Now, we just run the relevant code to generate something editable. This is
+// the function that does all the work of parsing out the 'extra' code and not
+// running it, but running everything else.
+void olc_from_proto(PROTO_DATA *proto,BUFFER *extra,void *me,void *aspy,
+		    void *togame,void *fromgame);
+
+
+
 //*****************************************************************************
 // To keep a general "look and feel" to OLCs, a couple functions have been
 // provided to display some features of an OLC in a standard manner.
